"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactAce = _interopRequireDefault(require("react-ace"));

var _Preview = _interopRequireDefault(require("./Preview.css"));

require("brace/mode/batchfile");

require("brace/mode/css");

require("brace/mode/html");

require("brace/mode/javascript");

require("brace/mode/json");

require("brace/mode/jsx");

require("brace/mode/markdown");

require("brace/mode/php");

require("brace/mode/sh");

require("brace/mode/text");

require("brace/theme/github");

require("brace/theme/monokai");

require("brace/theme/terminal");

require("brace/theme/tomorrow");

var _config = require("./config");

var _createHighlightMarkers = _interopRequireDefault(require("./createHighlightMarkers"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getLanguageTitle(value) {
  const found = _config.SUPPORTED_LANGUAGES.find(lang => lang.value === value);

  return found ? found.title : null;
}

class CodePreview extends _react.PureComponent {
  render() {
    const layout = this.props.layout;
    return layout === 'block' ? this.renderBlockPreview() : this.renderDefaultPreview();
  }

  renderDefaultPreview() {
    const value = this.props.value;
    return _react.default.createElement("div", {
      className: _Preview.default.defaultPreviewContainer
    }, _react.default.createElement("div", null, value && value.language ? getLanguageTitle(value.language) : 'Unknown language'));
  }

  renderBlockPreview() {
    const _this$props = this.props,
          value = _this$props.value,
          type = _this$props.type;
    const fixedLanguage = (0, _get2.default)(type, 'options.language');
    return _react.default.createElement("div", {
      className: _Preview.default.root
    }, _react.default.createElement("h3", null, value && getLanguageTitle(value.language)), _react.default.createElement("div", {
      className: _Preview.default.aceWrapper
    }, _react.default.createElement(_reactAce.default, {
      mode: value && value.language || fixedLanguage || 'text',
      theme: "monokai",
      width: "100%",
      height: null,
      maxLines: 200,
      readOnly: true,
      wrapEnabled: true,
      showPrintMargin: false,
      highlightActiveLine: false,
      cursorStart: -1,
      value: value && value.code || '',
      markers: value && value.highlightedLines ? (0, _createHighlightMarkers.default)(value.highlightedLines) : null,
      onLoad: this.handleEditorLoad,
      tabSize: 2,
      showGutter: false,
      setOptions: _config.ACE_SET_OPTIONS,
      editorProps: _config.ACE_EDITOR_PROPS
    })));
  }

}

exports.default = CodePreview;

_defineProperty(CodePreview, "propTypes", {
  type: _propTypes.default.object,
  layout: _propTypes.default.string,
  value: _propTypes.default.shape({
    _type: _propTypes.default.string,
    code: _propTypes.default.string,
    language: _propTypes.default.string,
    highlightedLines: _propTypes.default.array
  })
});